Index: trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFModel.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFModel.hh	(revision 1227)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFModel.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FTFModel.hh,v 1.10 2009/10/25 10:50:54 vuzhinsk Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 // Class Description
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFParameters.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFParameters.hh	(revision 1227)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFParameters.hh	(revision 1228)
@@ -28,5 +28,5 @@
 //
 // $Id: G4FTFParameters.hh,v 1.7 2009/10/25 10:50:54 vuzhinsk Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 #include "G4Proton.hh"
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFParticipants.hh
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFParticipants.hh	(revision 1227)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/include/G4FTFParticipants.hh	(revision 1228)
@@ -26,5 +26,5 @@
 //
 // $Id: G4FTFParticipants.hh,v 1.6 2009/08/03 13:14:19 vuzhinsk Exp $
-// GEANT4 tag $Name: geant4-09-03-cand-01 $
+// GEANT4 tag $Name: geant4-09-03 $
 //
 
Index: trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveExcitation.cc
===================================================================
--- trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveExcitation.cc	(revision 1227)
+++ trunk/source/processes/hadronic/models/parton_string/diffraction/src/G4DiffractiveExcitation.cc	(revision 1228)
@@ -25,5 +25,5 @@
 //
 //
-// $Id: G4DiffractiveExcitation.cc,v 1.16 2009/10/06 10:10:36 vuzhinsk Exp $
+// $Id: G4DiffractiveExcitation.cc,v 1.21 2009/12/15 19:14:31 vuzhinsk Exp $
 // ------------------------------------------------------------
 //      GEANT 4 class implemetation file
@@ -73,9 +73,8 @@
                      G4VSplitableHadron *target,
                      G4FTFParameters    *theParameters,
-                     G4ElasticHNScattering *theElastic) const  // Uzhi 03.09.09
+                     G4ElasticHNScattering *theElastic) const  
 {
 // -------------------- Projectile parameters -----------------------
      G4LorentzVector Pprojectile=projectile->Get4Momentum();
-//G4cout<<"Excite P "<<Pprojectile<<G4endl;
 
      if(Pprojectile.z() < 0.)
@@ -88,5 +87,4 @@
 
      G4int    ProjectilePDGcode=projectile->GetDefinition()->GetPDGEncoding();
-//     G4ParticleDefinition * ProjectileDefinition = projectile->GetDefinition();
      G4int    absProjectilePDGcode=std::abs(ProjectilePDGcode);
 
@@ -115,8 +113,4 @@
      G4double M0target = Ptarget.mag();
 
-//G4cout<<"Excite T "<<Ptarget<<G4endl;
-//G4cout<<"PDGs "<<ProjectilePDGcode<<" "<<TargetPDGcode<<G4endl;
-//G4cout<<"Masses "<<M0projectile<<" "<<M0target<<G4endl;
-
      G4double TargetRapidity = Ptarget.rapidity();
 
@@ -149,4 +143,5 @@
 
      G4LorentzVector Ptmp=toCms*Pprojectile;
+
      if ( Ptmp.pz() <= 0. )
      {
@@ -167,6 +162,6 @@
 
      G4double SqrtS=std::sqrt(S);
-//G4cout<<" SqrtS "<<SqrtS<<" 2200 "<<G4endl;
-     if(absProjectilePDGcode > 1000 && SqrtS < 2300*MeV && SqrtS < SumMasses)
+               
+     if(absProjectilePDGcode > 1000 && (SqrtS < 2300*MeV || SqrtS < SumMasses))
      {target->SetStatus(2);  return false;}  // The model cannot work for
                                              // p+p-interactions
@@ -174,5 +169,5 @@
 
      if(( absProjectilePDGcode == 211 || ProjectilePDGcode ==  111) && 
-        (SqrtS < 1600*MeV) && (SqrtS < SumMasses))
+        ((SqrtS < 1600*MeV) || (SqrtS < SumMasses)))
      {target->SetStatus(2);  return false;}  // The model cannot work for
                                              // Pi+p-interactions
@@ -181,5 +176,5 @@
      if(( (absProjectilePDGcode == 321) || (ProjectilePDGcode == -311)   ||
           (absProjectilePDGcode == 311) || (absProjectilePDGcode == 130) ||
-          (absProjectilePDGcode == 310)) && (SqrtS < 1600*MeV) && (SqrtS < SumMasses)) 
+          (absProjectilePDGcode == 310)) && ((SqrtS < 1600*MeV) || (SqrtS < SumMasses))) 
      {target->SetStatus(2);  return false;}  // The model cannot work for
                                              // K+p-interactions
@@ -223,6 +218,4 @@
 // Charge exchange can be possible for baryons -----------------
 
-//G4cout<<1./std::exp(-2.0*(ProjectileRapidity - TargetRapidity))<<G4endl;
-//G4int Uzhi; G4cin>>Uzhi;
 // Getting the values needed for exchange ----------------------
      G4double MagQuarkExchange        =theParameters->GetMagQuarkExchange();
@@ -231,5 +224,5 @@
 
 //     G4double NucleonMass=
-              (G4ParticleTable::GetParticleTable()->FindParticle(2112))->GetPDGMass();     
+//              (G4ParticleTable::GetParticleTable()->FindParticle(2112))->GetPDGMass();     
      G4double DeltaMass=
               (G4ParticleTable::GetParticleTable()->FindParticle(2224))->GetPDGMass();
@@ -239,10 +232,6 @@
         std::exp(-SlopeQuarkExchange*(ProjectileRapidity - TargetRapidity)))
      {    
-
-//G4cout<<"Exchange "<<G4endl;
-
       G4int NewProjCode(0), NewTargCode(0);
 
-//G4bool StandardExcitation(false); // ================================= 
       G4int ProjQ1(0), ProjQ2(0), ProjQ3(0);
 
@@ -264,9 +253,6 @@
       G4int TargExchangeQ(0);
 
-//G4cout<<"Targ "<<TargQ1<<" "<<TargQ2<<" "<<TargQ3<<G4endl;
       if(absProjectilePDGcode < 1000 )
       {    // projectile is meson ----------------- 
-//G4cout<<"Proj Q1 Q2 "<<ProjQ1<<" "<<ProjQ2<<G4endl;
-
        if(ProjQ1 > 0 ) // ProjQ1 is quark
        {  
@@ -283,5 +269,4 @@
          TargExchangeQ = TargQ3;  TargQ3=ProjExchangeQ; ProjQ1=TargExchangeQ;
         }
-//G4cout<<" Pr Tr "<<ProjQ1<<" "<<TargQ1<<" "<<TargQ2<<" "<<TargQ3<<G4endl;
        } else          // ProjQ2 is quark
        {  
@@ -310,9 +295,6 @@
        }
 
-//       projectile->SetDefinition(
-//       G4ParticleTable::GetParticleTable()->FindParticle(NewProjCode)); 
-
        NewTargCode = NewNucleonId(TargQ1, TargQ2, TargQ3);
- 
+
        if( (TargQ1 == TargQ2) && (TargQ1 == TargQ3) &&
            (SqrtS > M0projectile+DeltaMass))           {NewTargCode +=2;} //Create Delta isobar
@@ -326,13 +308,9 @@
                (SqrtS > M0projectile+DeltaMass))      {NewTargCode +=2;}  //Create Delta isobar
        else                                           {}                 //Save initial nucleon
-
-       target->SetDefinition(
-       G4ParticleTable::GetParticleTable()->FindParticle(NewTargCode)); 
-//G4cout<<"New PDGs "<<NewProjCode<<" "<<NewTargCode<<G4endl;
-//G4int Uzhi; G4cin>>Uzhi;
-       //}
+//       target->SetDefinition(                                          // Fix 15.12.09
+//       G4ParticleTable::GetParticleTable()->FindParticle(NewTargCode));// Fix 15.12.09 
       } else 
       {    // projectile is baryon ----------------
-G4double Same=0.; //0.3; //0.5;
+       G4double Same=0.; //0.3; //0.5;
        G4bool ProjDeltaHasCreated(false);
        G4bool TargDeltaHasCreated(false);
@@ -341,5 +319,4 @@
        if(G4UniformRand() < 0.5)     // Sampling exchange quark from proj. or targ.
        {   // Sampling exchanged quark from the projectile ---
-//G4cout<<"Proj Exc"<<G4endl;
         if( Ksi < 0.333333 ) 
         {ProjExchangeQ = ProjQ1;}
@@ -348,11 +325,10 @@
         else
         {ProjExchangeQ = ProjQ3;}
-//G4cout<<"ProjExchangeQ "<<ProjExchangeQ<<G4endl;
-
-        if((ProjExchangeQ != TargQ1)||(G4UniformRand()<Same)) // Vova
+
+        if((ProjExchangeQ != TargQ1)||(G4UniformRand()<Same)) 
         {
          TargExchangeQ = TargQ1; TargQ1=ProjExchangeQ; ProjExchangeQ=TargExchangeQ;
         } else
-        if((ProjExchangeQ != TargQ2)||(G4UniformRand()<Same)) // Vova
+        if((ProjExchangeQ != TargQ2)||(G4UniformRand()<Same)) 
         {
          TargExchangeQ = TargQ2; TargQ2=ProjExchangeQ; ProjExchangeQ=TargExchangeQ;
@@ -361,5 +337,5 @@
          TargExchangeQ = TargQ3;  TargQ3=ProjExchangeQ; ProjExchangeQ=TargExchangeQ;
         }
-//G4cout<<"ProjExchangeQ "<<ProjExchangeQ<<G4endl;
+
         if( Ksi < 0.333333 ) 
         {ProjQ1=ProjExchangeQ;}
@@ -369,59 +345,6 @@
         {ProjQ3=ProjExchangeQ;}
 
-/*
-        NewProjCode = NewNucleonId(ProjQ1, ProjQ2, ProjQ3); // *****************************
-
-        if((ProjQ1==ProjQ2) && (ProjQ1==ProjQ3)) {NewProjCode +=2; ProjDeltaHasCreated=true;}
-        else if(projectile->GetDefinition()->GetPDGiIsospin() == 3)// Projectile was Delta
-        { if(G4UniformRand() > DeltaProbAtQuarkExchange)
-                                                 {NewProjCode +=2; ProjDeltaHasCreated=true;} 
-          else                                   {NewProjCode +=0; ProjDeltaHasCreated=false;}
-        }
-        else                                                       // Projectile was Nucleon
-        {
-         if((G4UniformRand() < DeltaProbAtQuarkExchange) && (SqrtS > DeltaMass+M0target)) 
-                                                 {NewProjCode +=2; ProjDeltaHasCreated=true;}
-         else                                    {NewProjCode +=0; ProjDeltaHasCreated=false;}
-        } 
-
-        NewTargCode = NewNucleonId(TargQ1, TargQ2, TargQ3); // *****************************
-
-        if((TargQ1==TargQ2) && (TargQ1==TargQ3)) {NewTargCode +=2; TargDeltaHasCreated=true;}  
-        else if(target->GetDefinition()->GetPDGiIsospin() == 3)    // Target was Delta
-        { if(G4UniformRand() > DeltaProbAtQuarkExchange)
-                                                 {NewTargCode +=2; TargDeltaHasCreated=true;} 
-          else                                   {NewTargCode +=0; TargDeltaHasCreated=false;}
-        }
-        else                                                       // Target was Nucleon
-        {
-         if((G4UniformRand() < DeltaProbAtQuarkExchange) && (SqrtS > M0projectile+DeltaMass)) 
-                                                 {NewTargCode +=2; TargDeltaHasCreated=true;}
-         else                                    {NewTargCode +=0; TargDeltaHasCreated=false;}
-        }         
-
-        if((absProjectilePDGcode == NewProjCode) && (absTargetPDGcode == NewTargCode))
-        { // Nothing was changed! It is not right!?
-        }
-*/
-/*-----------------------------------------------------------------------------------------
-        if(!ProjDeltaHasCreated && !TargDeltaHasCreated) // No Deltas were created then
-        { if( G4UniformRand() < 0.5) {NewProjCode +=2; ProjDeltaHasCreated = true;}
-          else                       {NewTargCode +=2; TargDeltaHasCreated = true;} 
-        }
-
-        if(!(ProjDeltaHasCreated && TargDeltaHasCreated))
-        {
-         if((G4UniformRand() < DeltaProbAtQuarkExchange) && (SqrtS >2600.)) 
-         { 
-G4cout<<"2 Deltas "<<G4endl;
-          if(!ProjDeltaHasCreated)
-               {NewProjCode +=2; ProjDeltaHasCreated = true;}
-          else {NewTargCode +=2; TargDeltaHasCreated = true;} // For Delta isobar
-         }
-        }
-*/
        } else
        {   // Sampling exchanged quark from the target -------
-//G4cout<<"Targ Exc"<<G4endl;
         if( Ksi < 0.333333 ) 
         {TargExchangeQ = TargQ1;}
@@ -430,10 +353,10 @@
         else
         {TargExchangeQ = TargQ3;}
-//G4cout<<"TargExchangeQ "<<TargExchangeQ<<G4endl;
-        if((TargExchangeQ != ProjQ1)||(G4UniformRand()<Same)) // Vova
+
+        if((TargExchangeQ != ProjQ1)||(G4UniformRand()<Same)) 
         {
          ProjExchangeQ = ProjQ1; ProjQ1=TargExchangeQ; TargExchangeQ=ProjExchangeQ;
         } else
-        if((TargExchangeQ != ProjQ2)||(G4UniformRand()<Same)) // Vova
+        if((TargExchangeQ != ProjQ2)||(G4UniformRand()<Same)) 
         {
          ProjExchangeQ = ProjQ2; ProjQ2=TargExchangeQ; TargExchangeQ=ProjExchangeQ;
@@ -442,5 +365,5 @@
          ProjExchangeQ = ProjQ3;  ProjQ3=TargExchangeQ; TargExchangeQ=ProjExchangeQ;
         }
-//G4cout<<"TargExchangeQ "<<TargExchangeQ<<G4endl;
+
         if( Ksi < 0.333333 ) 
         {TargQ1=TargExchangeQ;}
@@ -449,27 +372,5 @@
         else
         {TargQ3=TargExchangeQ;}
-/*
-        NewProjCode = NewNucleonId(ProjQ1, ProjQ2, ProjQ3);
-        if( (ProjQ1 == ProjQ2) && (ProjQ1 == ProjQ3) )  
-        {NewProjCode +=2; ProjDeltaHasCreated = true;}
-
-        NewTargCode = NewNucleonId(TargQ1, TargQ2, TargQ3);
-        if( (TargQ1 == TargQ2) && (TargQ1 == TargQ3) )  
-        {NewTargCode +=2; TargDeltaHasCreated = true;}
-
-        if(!ProjDeltaHasCreated && !TargDeltaHasCreated)
-        {NewTargCode +=2; TargDeltaHasCreated = true;}
-
-        if(!(ProjDeltaHasCreated && TargDeltaHasCreated))
-        {
-         if((G4UniformRand() < DeltaProbAtQuarkExchange) && (SqrtS >2600.)) 
-         { 
-G4cout<<"2 Deltas "<<G4endl;
-          if(!ProjDeltaHasCreated)
-               {NewProjCode +=2; ProjDeltaHasCreated = true;}
-          else {NewTargCode +=2; TargDeltaHasCreated = true;}
-         }
-        }
-*/
+
        } // End of sampling baryon
 
@@ -509,8 +410,4 @@
 // Forming baryons --------------------------------------------------
 
-//       if( ProjDeltaHasCreated && TargDeltaHasCreated ) {StandardExcitation = true;}
-
-//G4cout<<"New PDG "<<NewProjCode<<" "<<NewTargCode<<G4endl;
-//G4int Uzhi; G4cin>>Uzhi;
       } // End of if projectile is baryon ---------------------------
 
@@ -518,4 +415,5 @@
 // If we assume that final state hadrons after the charge exchange will be
 // in the ground states, we have to put ----------------------------------
+
       if(M0projectile < 
          (G4ParticleTable::GetParticleTable()->FindParticle(NewProjCode))->GetPDGMass())
@@ -537,6 +435,4 @@
              2*S*M0projectile2 - 2*S*M0target2 - 2*M0projectile2*M0target2)
              /4./S;
-//G4cout<<"New Masses "<<M0projectile<<" "<<M0target<<G4endl;
-//G4cout<<"PZcms2 "<<PZcms2<<G4endl;
 
       if(PZcms2 < 0) {return false;}  // It can be if energy is not sufficient for Delta
@@ -556,8 +452,4 @@
       Ptarget.setE(std::sqrt(M0target2+PZcms2));
 
-//G4cout<<"Proj "<<Pprojectile<<" "<<Pprojectile.mag()<<G4endl;
-//G4cout<<"Targ "<<Ptarget<<" "<<Ptarget.mag()<<G4endl;
-
-//      if(!StandardExcitation)
       {
        Pprojectile.transform(toLab);
@@ -571,30 +463,10 @@
 
        G4bool Result= theElastic->ElasticScattering (projectile,target,theParameters);
-//G4cout<<"1 Delta result "<<Result<<"**********"<<G4endl;
+
        return Result;
       } 
-/*
-else
-      {
-       if(M0projectile > ProjectileDiffStateMinMass) 
-       { ProjectileDiffStateMinMass +=200.*MeV; ProjectileNonDiffStateMinMass +=200.*MeV;}
-
-       if(M0target > TargetDiffStateMinMass) 
-       { TargetDiffStateMinMass +=200.*MeV; TargetNonDiffStateMinMass +=200.*MeV;}
-
-       ProbOfDiffraction         = 1.;
-       ProbProjectileDiffraction =0.5;
-       ProbTargetDiffraction     =0.5;
-G4cout<<"Exc DD "<<M0projectile<<" "<<M0target<<" --------------------"<<G4endl;
-//       After that standard FTF excitation
-      }
-*/
      }  // End of charge exchange part ------------------------------
 
 // ------------------------------------------------------------------
-//     G4double ProbOfDiffraction=ProbProjectileDiffraction +
-//                                ProbTargetDiffraction;
-//G4cout<<ProbOfDiffraction<<" "<<ProbProjectileDiffraction<<" "<<ProbTargetDiffraction<<G4endl;
-//G4int Uzhi; G4cin>>Uzhi;
      if(ProbOfDiffraction!=0.)
      {
@@ -606,6 +478,4 @@
      }
 
-//ProbOfDiffraction=1.; //0.5; // Vova 
-
      G4double ProjectileDiffStateMinMass2    = ProjectileDiffStateMinMass    *
                                                ProjectileDiffStateMinMass;
@@ -617,5 +487,4 @@
      G4double TargetNonDiffStateMinMass2     = TargetNonDiffStateMinMass     *
                                                TargetNonDiffStateMinMass;
-
 
      G4double Pt2;
@@ -637,5 +506,4 @@
         if(G4UniformRand() < ProbProjectileDiffraction)
         { //-------- projectile diffraction ---------------
-//G4cout<<"Proj difr"<<G4endl;
          do {
 //             Generate pt
@@ -659,5 +527,5 @@
                      2.*S*ProjMassT2-2.*S*TargMassT2-2.*ProjMassT2*TargMassT2)
                     /4./S;
-//G4cout<<"PZcms2 < 0 false "<<PZcms2<<G4endl;
+
              if(PZcms2 < 0 ) 
              {
@@ -703,5 +571,4 @@
         { // -------------- Target diffraction ----------------
          do {
-//G4cout<<"Targ difr"<<G4endl;
 //             Generate pt
 //             if (whilecount++ >= 500 && (whilecount%100)==0)
@@ -770,5 +637,4 @@
         else  //----------- Non-diffraction process ------------
         {
-//G4cout<<"Non difr"<<G4endl;
          do {
 //             Generate pt
@@ -841,7 +707,4 @@
 	   Ptarget     -= Qmomentum;
 
-//G4cout<<"Masses "<<Pprojectile.mag()<<" "<<Ptarget.mag()<<G4endl;
-//G4int Uzhi; G4cin>>Uzhi;
-
 // Transform back and update SplitableHadron Participant.
 	   Pprojectile.transform(toLab);
@@ -865,6 +728,4 @@
 
 // ---------------------------------------------------------------------
-//G4ExcitedString * G4DiffractiveExcitation::
-//           String(G4VSplitableHadron * hadron, G4bool isProjectile) const
 void G4DiffractiveExcitation::CreateStrings(G4VSplitableHadron * hadron, 
                                             G4bool isProjectile,
@@ -886,11 +747,7 @@
 	  return;
 	}
+
         G4LorentzVector Phadron=hadron->Get4Momentum();
-/*
-G4cout<<"Create strings had "<<hadron->GetDefinition()->GetParticleName()<<" "<<Phadron<<" "<<Phadron.mag()<<G4endl;
-G4cout<<"isProjectile "<<isProjectile<<G4endl;
-G4cout<<"start Q "<<start->GetDefinition()->GetPDGEncoding()<<G4endl;
-G4cout<<"end   Q "<<end->GetDefinition()->GetPDGEncoding()<<G4endl;
-*/
+
         G4LorentzVector Pstart(0.,0.,0.,0.);
         G4LorentzVector Pend(0.,0.,0.,0.);
@@ -914,5 +771,5 @@
         G4double W = hadron->Get4Momentum().mag();
         G4double W2=W*W;
-//G4cout<<"W Wmin "<<W<<" "<<Wmin<<G4endl;
+
         G4double Pt(0.), x1(0.), x2(0.), x3(0.);
         G4bool Kink=false;
@@ -922,15 +779,14 @@
           G4double Pt2kink=theParameters->GetPt2Kink();
           Pt = std::sqrt(Pt2kink*(std::pow(W2/16./Pt2kink+1.,G4UniformRand()) - 1.));
-// Pt=0.;
-//G4cout<<"Pt2kink Pt Pt2 "<<Pt2kink<<" "<<Pt<<" "<<Pt*Pt<<G4endl;
+
           if(Pt > 500.*MeV)
           {
              G4double Ymax = std::log(W/2./Pt + std::sqrt(W2/4./Pt/Pt - 1.));
              G4double Y=Ymax*(1.- 2.*G4UniformRand());
-//G4cout<<"Ymax Y "<<Ymax<<" "<<Y<<G4endl;
+
              x1=1.-Pt/W*std::exp( Y);
              x3=1.-Pt/W*std::exp(-Y);
              x2=2.-x1-x3;
-//G4cout<<"X1 X2 X3 "<<x1<<" "<<x2<<" "<<x3<<G4endl;
+
              G4double Mass_startQ = 650.*MeV;
              if(PDGcode_startQ <  3) Mass_startQ =  325.*MeV;
@@ -947,6 +803,6 @@
      
              G4double P2_2=sqr((2.-x1-x3)*W/2.);
-//G4cout<<"P2_1 P2_2 P2_3 "<<P2_1<<" "<<P2_2<<" "<<P2_3<<G4endl;
-             if((P2_1 < 0.) || (P2_3 <0.))
+
+             if((P2_1 <= 0.) || (P2_3 <= 0.))
              { Kink=false;}
              else
@@ -955,8 +811,9 @@
                G4double P_2=std::sqrt(P2_2);
                G4double P_3=std::sqrt(P2_3);
-//G4cout<<"P_1 P_2 P_3 "<<P_1<<" "<<P_2<<" "<<P_3<<G4endl;
+
                G4double CosT12=(P2_3-P2_1-P2_2)/(2.*P_1*P_2);
                G4double CosT13=(P2_2-P2_1-P2_3)/(2.*P_1*P_3);
-//G4cout<<"CosT12 CosT13 "<<CosT12<<" "<<CosT13<<" "<<std::acos(CosT12)*180./3.14159<<" "<<std::acos(CosT13)*180./3.14159<<G4endl;
+//             Pt=P_2*std::sqrt(1.-CosT12*CosT12);  // because system was rotated 11.12.09
+
                if((std::abs(CosT12) >1.) || (std::abs(CosT13) > 1.)) 
                { Kink=false;}
@@ -964,4 +821,5 @@
                { 
                  Kink=true; 
+                 Pt=P_2*std::sqrt(1.-CosT12*CosT12);  // because system was rotated 11.12.09
                  Pstart.setPx(-Pt); Pstart.setPy(0.); Pstart.setPz(P_3*CosT13); 
                  Pend.setPx(   0.); Pend.setPy(  0.); Pend.setPz(          P_1); 
@@ -981,15 +839,8 @@
                  PkinkQ2=Pkink - PkinkQ1;
 //------------------------- Minimizing Pt1^2+Pt3^2 ------------------------------
-/*
-G4cout<<"Pstart "<<Pstart<<G4endl;
-G4cout<<"Pkink  "<<Pkink <<G4endl;
-G4cout<<"Pkink1 "<<PkinkQ1<<G4endl;
-G4cout<<"Pkink2 "<<PkinkQ2<<G4endl;
-G4cout<<"Pend   "<<Pend  <<G4endl;
-*/
+
                  G4double Cos2Psi=(sqr(x1) -sqr(x3)+2.*sqr(x3*CosT13))/
                           std::sqrt(sqr(sqr(x1)-sqr(x3)) + sqr(2.*x1*x3*CosT13));
                  G4double Psi=std::acos(Cos2Psi);
-//G4cout<<"Psi "<<Psi<<" "<<Psi*180./twopi<<G4endl;
 
 G4LorentzRotation Rotate;
@@ -997,6 +848,4 @@
 else             {Rotate.rotateY(pi-Psi);}                   
 Rotate.rotateZ(twopi*G4UniformRand());
-
-//G4cout<<"Rotate"<<G4endl;
 
 Pstart*=Rotate;
@@ -1005,10 +854,5 @@
 PkinkQ2*=Rotate;
 Pend*=Rotate;
-/*
-G4cout<<"Pstart "<<Pstart<<G4endl;
-G4cout<<"Pkink1 "<<PkinkQ1 <<G4endl;
-G4cout<<"Pkink2 "<<PkinkQ2 <<G4endl;
-G4cout<<"Pend   "<<Pend  <<G4endl;
-*/
+
                }
              }      // end of if((P2_1 < 0.) || (P2_3 <0.))
@@ -1018,6 +862,4 @@
 //--------------------------------------------------------------------------------
 
-//G4cout<<"Kink "<<Kink<<G4endl;
-
         if(Kink)
         {                                        // Kink is possible
@@ -1028,37 +870,13 @@
           for(unsigned int Iq=0; Iq <3; Iq++)
           {
-//G4cout<<Iq<<" "<<QuarkProbabilitiesAtGluonSplitUp[Iq]<<G4endl;
+
 if(Ksi > QuarkProbabilitiesAtGluonSplitUp[Iq]) QuarkInGluon++;}
 
-//G4cout<<"Gquark "<<QuarkInGluon<<G4endl;
           G4Parton * Gquark = new G4Parton(QuarkInGluon);
           G4Parton * Ganti_quark = new G4Parton(-QuarkInGluon);
-/*
-G4cout<<Gquark->GetDefinition()->GetParticleName()<<" "<<Gquark->GetDefinition()->GetPDGEncoding()<<" "<<Gquark->GetDefinition()->GetPDGMass()<<G4endl;
-G4cout<<Ganti_quark->GetDefinition()->GetParticleName()<<" "<<Ganti_quark->GetDefinition()->GetPDGEncoding()<<" "<<Ganti_quark->GetDefinition()->GetPDGMass()<<G4endl;
-*/
-
-//G4int Uzhi; G4cin>>Uzhi;
 
 //-------------------------------------------------------------------------------
-/*
-DefineMomentumInZ(G4double aLightConeMomentum, G4bool aDirection); 
-      void Set4Momentum(const G4LorentzVector & aMomentum);
-      G4int PDGencoding;
-      G4ParticleDefinition * theDefinition;
-      G4LorentzVector theMomentum;
-      G4ThreeVector   thePosition;
-      
-      G4int theColour;
-      G4double theIsoSpinZ;
-      G4double theSpinZ;
-      
-      G4double theX;
-*/
-//-------------------------------------------------------------------------------
-
-//G4cout<<"Phadron "<<Phadron<<" mass "<<Phadron.mag()<<G4endl;
           G4LorentzRotation toCMS(-1*Phadron.boostVector());
-//G4cout<<"To lab"<<G4endl;
+
           G4LorentzRotation toLab(toCMS.inverse());
 
@@ -1067,14 +885,6 @@
           PkinkQ2.transform(toLab);
           Pend.transform(toLab);    end->Set4Momentum(Pend);
-/*
-G4cout<<"Pstart "<<start->GetDefinition()->GetPDGEncoding()<<Pstart<<G4endl;
-G4cout<<"Pkink1 "<<PkinkQ1 <<G4endl;
-G4cout<<"Pkink2 "<<PkinkQ2 <<G4endl;
-G4cout<<"Pend   "<<end->GetDefinition()->GetPDGEncoding()<<Pend  <<G4endl;
-*/
-// !!!	  G4ExcitedString * FirstString(0); G4ExcitedString * SecondString(0);
+
           G4int absPDGcode=std::abs(hadron->GetDefinition()->GetPDGEncoding());
-
-//G4cout<<"absPDGcode "<<absPDGcode<<G4endl;
 
           if(absPDGcode < 1000)
@@ -1088,16 +898,5 @@
                 Ganti_quark->Set4Momentum(PkinkQ1);
                 Gquark->Set4Momentum(PkinkQ2);
-/*
-G4cout<<" Proj Meson end Q"<<G4endl;
-G4cout<<"First string  ============ "<<G4endl;
-G4cout<<"end  Q "<<end->GetDefinition()->GetPDGEncoding()<<" "<<end->Get4Momentum()<<G4endl;
-G4cout<<"G antiQ"<<Ganti_quark->GetDefinition()->GetPDGEncoding()<<" "<<Ganti_quark->Get4Momentum()<<G4endl;
-G4cout<<"Sum P  "<<(Ganti_quark->Get4Momentum()+end->Get4Momentum())<<G4endl;
-G4cout<<"Secondstring   ============ "<<G4endl;
-G4cout<<"G    Q "<<Gquark->GetDefinition()->GetPDGEncoding()<<" "<<Gquark->Get4Momentum()<<G4endl;
-G4cout<<"startQ "<<start->GetDefinition()->GetPDGEncoding()<<" "<<start->Get4Momentum()<<G4endl;
-
-G4cout<<"Sum P  "<<(Gquark->Get4Momentum()+start->Get4Momentum())<<G4endl;
-*/
+
               } else
               {                            // Anti_Quark on the end
@@ -1106,15 +905,5 @@
                 Gquark->Set4Momentum(PkinkQ1);
                 Ganti_quark->Set4Momentum(PkinkQ2);
-/*
-G4cout<<" Proj Meson end Qbar"<<G4endl;
-G4cout<<"First string  ============ "<<G4endl;
-G4cout<<"end  Q "<<end->GetDefinition()->GetPDGEncoding()<<" "<<end->Get4Momentum()<<G4endl;
-G4cout<<"G     Q"<<Gquark->GetDefinition()->GetPDGEncoding()<<" "<<Gquark->Get4Momentum()<<G4endl;
-G4cout<<"Sum P  "<<(Gquark->Get4Momentum()+end->Get4Momentum())<<G4endl;
-G4cout<<"Secondstring   ============ "<<G4endl;
-G4cout<<"G antQ "<<Ganti_quark->GetDefinition()->GetPDGEncoding()<<" "<<Ganti_quark->Get4Momentum()<<G4endl;
-G4cout<<"startQ "<<start->GetDefinition()->GetPDGEncoding()<<" "<<start->Get4Momentum()<<G4endl;
-G4cout<<"Sum P  "<<(Ganti_quark->Get4Momentum()+start->Get4Momentum())<<G4endl;
-*/
+
               }   // end of if(end->GetPDGcode() > 0)
             } else {                      // Target
@@ -1125,15 +914,5 @@
                 Ganti_quark->Set4Momentum(PkinkQ2);
                 Gquark->Set4Momentum(PkinkQ1);
-/*
-G4cout<<" Targ Meson end Q"<<G4endl;
-G4cout<<"First string   ============ "<<G4endl;
-G4cout<<"G antiQ"<<Ganti_quark->GetDefinition()->GetPDGEncoding()<<" "<<Ganti_quark->Get4Momentum()<<G4endl;
-G4cout<<"end  Q "<<end->GetDefinition()->GetPDGEncoding()<<" "<<end->Get4Momentum()<<G4endl;
-G4cout<<"Sum P  "<<(Ganti_quark->Get4Momentum()+end->Get4Momentum())<<G4endl;
-G4cout<<"Secondstring   ============ "<<G4endl;
-G4cout<<"startQ "<<start->GetDefinition()->GetPDGEncoding()<<" "<<start->Get4Momentum()<<G4endl;
-G4cout<<"G    Q "<<Gquark->GetDefinition()->GetPDGEncoding()<<" "<<Gquark->Get4Momentum()<<G4endl;
-G4cout<<"Sum P  "<<(Gquark->Get4Momentum()+start->Get4Momentum())<<G4endl;
-*/
+
               } else
               {                            // Anti_Quark on the end
@@ -1142,15 +921,5 @@
                 Gquark->Set4Momentum(PkinkQ2);
                 Ganti_quark->Set4Momentum(PkinkQ1);
-/*
-G4cout<<" Targ Meson end Qbar"<<G4endl;
-G4cout<<"First string   ============ "<<G4endl;
-G4cout<<"G     Q"<<Gquark->GetDefinition()->GetPDGEncoding()<<" "<<Gquark->Get4Momentum()<<G4endl;
-G4cout<<"end  Q "<<end->GetDefinition()->GetPDGEncoding()<<" "<<end->Get4Momentum()<<G4endl;
-G4cout<<"Sum P  "<<(Gquark->Get4Momentum()+end->Get4Momentum())<<G4endl;
-G4cout<<"Secondstring   ============ "<<G4endl;
-G4cout<<"startQ "<<start->GetDefinition()->GetPDGEncoding()<<" "<<start->Get4Momentum()<<G4endl;
-G4cout<<"G antQ "<<Ganti_quark->GetDefinition()->GetPDGEncoding()<<" "<<Ganti_quark->Get4Momentum()<<G4endl;
-G4cout<<"Sum P  "<<(Ganti_quark->Get4Momentum()+start->Get4Momentum())<<G4endl;
-*/
+
               }   // end of if(end->GetPDGcode() > 0)
 	    }     // end of if ( isProjectile )
@@ -1166,15 +935,5 @@
                 Gquark->Set4Momentum(PkinkQ1);
                 Ganti_quark->Set4Momentum(PkinkQ2);
-/*
-G4cout<<" Proj baryon end QQ"<<G4endl;
-G4cout<<"First string   ============ "<<G4endl;
-G4cout<<"end OQ "<<end->GetDefinition()->GetPDGEncoding()<<" "<<end->Get4Momentum()<<G4endl;
-G4cout<<"G    Q"<<Gquark->GetDefinition()->GetPDGEncoding()<<" "<<Gquark->Get4Momentum()<<G4endl;
-G4cout<<"Sum P  "<<(Gquark->Get4Momentum()+end->Get4Momentum())<<G4endl;
-G4cout<<"Secondstring   ============ "<<G4endl;
-G4cout<<"G  Qbar"<<Ganti_quark->GetDefinition()->GetPDGEncoding()<<" "<<Ganti_quark->Get4Momentum()<<G4endl;
-G4cout<<"startQ "<<start->GetDefinition()->GetPDGEncoding()<<" "<<start->Get4Momentum()<<G4endl;
-G4cout<<"Sum P  "<<(Ganti_quark->Get4Momentum()+start->Get4Momentum())<<G4endl;
-*/
+
               } else
               {                            // Anti_DiQuark on the end or quark
@@ -1183,15 +942,5 @@
                 Ganti_quark->Set4Momentum(PkinkQ1);
                 Gquark->Set4Momentum(PkinkQ2);
-/*
-G4cout<<" Proj baryon end Q"<<G4endl;
-G4cout<<"First string   ============ "<<G4endl;
-G4cout<<"end OQ "<<end->GetDefinition()->GetPDGEncoding()<<" "<<end->Get4Momentum()<<G4endl;
-G4cout<<"G antQ"<<Ganti_quark->GetDefinition()->GetPDGEncoding()<<" "<<Ganti_quark->Get4Momentum()<<G4endl;
-G4cout<<"Sum P  "<<(Ganti_quark->Get4Momentum()+end->Get4Momentum())<<G4endl;
-G4cout<<"Secondstring   ============ "<<G4endl;
-G4cout<<"G  Q   "<<Gquark->GetDefinition()->GetPDGEncoding()<<" "<<Gquark->Get4Momentum()<<G4endl;
-G4cout<<"startQ "<<start->GetDefinition()->GetPDGEncoding()<<" "<<start->Get4Momentum()<<G4endl;
-G4cout<<"Sum P  "<<(Gquark->Get4Momentum()+start->Get4Momentum())<<G4endl;
-*/
+
               }   // end of if(end->GetPDGcode() > 0)
             } else {                      // Target
@@ -1205,15 +954,5 @@
                 Gquark->Set4Momentum(PkinkQ1);
                 Ganti_quark->Set4Momentum(PkinkQ2);
-/*
-G4cout<<" Targ baryon end QQ"<<G4endl;
-G4cout<<"First string   ============ "<<G4endl;
-G4cout<<"G  Q   "<<Gquark->GetDefinition()->GetPDGEncoding()<<" "<<Gquark->Get4Momentum()<<G4endl;
-G4cout<<"end OQ "<<end->GetDefinition()->GetPDGEncoding()<<" "<<end->Get4Momentum()<<G4endl;
-G4cout<<"Sum P  "<<(Gquark->Get4Momentum()+end->Get4Momentum())<<G4endl;
-G4cout<<"Secondstring   ============ "<<G4endl;
-G4cout<<"startQ "<<start->GetDefinition()->GetPDGEncoding()<<" "<<start->Get4Momentum()<<G4endl;
-G4cout<<"G  Qbar"<<Ganti_quark->GetDefinition()->GetPDGEncoding()<<" "<<Ganti_quark->Get4Momentum()<<G4endl;
-G4cout<<"Sum P  "<<(Ganti_quark->Get4Momentum()+start->Get4Momentum())<<G4endl;
-*/
+
               } else
               {                            // Anti_DiQuark on the end or Q
@@ -1222,15 +961,5 @@
                 Gquark->Set4Momentum(PkinkQ2);
                 Ganti_quark->Set4Momentum(PkinkQ1);
-/*
-G4cout<<" Targ baryon end Q"<<G4endl;
-G4cout<<"First string   ============ "<<G4endl;
-G4cout<<"G  Qbar"<<Ganti_quark->GetDefinition()->GetPDGEncoding()<<" "<<Ganti_quark->Get4Momentum()<<G4endl;
-G4cout<<"end O "<<end->GetDefinition()->GetPDGEncoding()<<" "<<end->Get4Momentum()<<G4endl;
-G4cout<<"Sum P  "<<(Ganti_quark->Get4Momentum()+end->Get4Momentum())<<G4endl;
-G4cout<<"Secondstring   ============ "<<G4endl;
-G4cout<<"startQ "<<start->GetDefinition()->GetPDGEncoding()<<" "<<start->Get4Momentum()<<G4endl;
-G4cout<<"G  Q   "<<Gquark->GetDefinition()->GetPDGEncoding()<<" "<<Gquark->Get4Momentum()<<G4endl;
-G4cout<<"Sum P  "<<(Gquark->Get4Momentum()+start->Get4Momentum())<<G4endl;
-*/
+
               }   // end of if(end->GetPDGcode() > 0)
 	    }     // end of if ( isProjectile )
@@ -1346,8 +1075,11 @@
 {            //  @@ this method is used in FTFModel as well. Should go somewhere common!
 
-	G4double Pt2;
-        Pt2 = -AveragePt2 * std::log(1. + G4UniformRand() * 
-                           (std::exp(-maxPtSquare/AveragePt2)-1.));
-
+	G4double Pt2(0.);
+        if(AveragePt2 <= 0.) {Pt2=0.;}
+        else
+        {
+         Pt2 = -AveragePt2 * std::log(1. + G4UniformRand() * 
+                            (std::exp(-maxPtSquare/AveragePt2)-1.));
+        }
 	G4double Pt=std::sqrt(Pt2);
 	G4double phi=G4UniformRand() * twopi;
